/*
 * ScaledImage.fx
 *
 */

package apidemo4;

/**
 * @author Jeff Friesen
 */

import javafx.animation.Interpolator;
import javafx.animation.Timeline;

import javafx.application.Frame;
import javafx.application.Stage;

import javafx.input.MouseEvent;

import javafx.scene.image.Image;
import javafx.scene.image.ImageView;

import javafx.scene.paint.Color;

class Model
{
    attribute url: String;
    attribute scale: Number = 1.0;
    
    private attribute timelineShrinkEnlarge = Timeline
    {
        toggle: true
                         
        var begin = at (0s)
        {
            scale => 1.0
        }

        var end = at (1s)
        {
            scale => 0.1 tween Interpolator.LINEAR
        }
                       
        keyFrames: [begin, end]
    }
  
    function animate ()
    {
        timelineShrinkEnlarge.start ()
    }
}

Frame
{
    var model = Model
    {
        url: "{__DIR__}3frogs.jpg"
    }
    
    width: 400
    height: 400
    
    var stageRef: Stage
    stage: stageRef = Stage
    {
        fill: Color.BLACK
        
        content: ImageView
        {
            var imageRef: Image
            image: bind imageRef = Image
            {
                url: model.url
            }
                             
            x: bind (stageRef.width-imageRef.width)/2
            y: bind (stageRef.height-imageRef.height)/2

            scaleX: bind model.scale
            scaleY: bind model.scale
                     
            onMouseEntered: function (me: MouseEvent)
            {
                model.animate ()
            }
        }
    }
        
    visible: true
}
